<template>
    <div>
        <form class="formStyle" @submit.prevent="handleSubmit">

            <label>Type a word, then press "," to validate</label>
            <input type="text" v-model="userInput" @keyup="handleKey">

            <div class="choiceList">
                <div v-for="value in values" :key="value">
                    <span class="wordTag" @click="deleteValue(value)">{{ value }}</span>
                </div>
            </div>

            <button type="submit" text="Random">Submit choices</button>
        </form>

        <p>{{ choice }}</p>
    </div>
</template>

<script lang="ts">
export default {
    data() {
        return {
            userInput: "",
            choice: null,
            values: new Array<string>()
        }
    },
    methods: {
        handleKey(event: KeyboardEvent) {
            if (event.key === "," && this.userInput) {
                if (!this.values.includes(this.userInput)) {
                    this.values.push(this.userInput.slice(0, -1))
                }
                this.userInput = ""
            }
        },
        deleteValue(value: string) {
            this.values = this.values.filter(val => val !== value);
        },
        handleSubmit() {
            if (this.values) {
                const body = {
                    values: this.values
                }
                fetch("http://localhost:4010/", {
                    method: "POST",
                    headers: {
                        "Content-Type": "application/json"
                    },
                    body: JSON.stringify(body)
                }).then((response) => {
                    return response.json()
                }).then((json) => {
                    this.choice = json
                })
            }
        },
    }
}
</script>

<style scoped>
.wordTag {
    background: var(--vt-c-green);
    color: var(--vt-c-base);
    padding: 0.5rem 1rem;
    margin: 0.5rem;
    border-radius: 20px;
    text-align: center;
    cursor: pointer;
    transition: background-color 0.2s;
}

.wordTag:hover {
    background-color: var(--vt-c-peach);
}

.choiceList {
    display: flex;
}

.formStyle {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
}
</style>

